<?php
/*

>>>>>> CrazyStat <<<<<<
Ein komfortables, umfangreiches und kostenloses Statistik-Script mit oder ohne Counter.

Copyright (C) 2004-2008  Crazy Chrissi

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

E-Mail: christosoft4u AT yahoo DOT de
Web: http://www.christosoft.de
Version: 1.62 (0-Bugfix A included)

*** kreisdiagramm.php ***
Funktion:    erzeugt Kreisdiagramm
Aufrufbar:   nein
Eingebunden: von show_stat.php (als Bild)
*/

if(!isset($_GET['modul'])) die('Fehler beim &Uuml;bermitteln des Moduls.');

session_start();
require_once('config.php');

if(isset($_GET['size']) && is_numeric($_GET['size'])) $breite=$_GET['size'];
else $breite=$config_stat_kreisdiagramm_groesse;
$hoehe=$breite;

// Fuer Kantenglaettung
if(!is_callable('imagecreatetruecolor') || !is_callable('imagecopyresampled')) $glaett_faktor=1;
else $glaett_faktor=4;
$orig_breite=$breite;
$orig_hoehe=$hoehe;
$breite*=$glaett_faktor;
$hoehe*=$glaett_faktor;


if(!isset($_SESSION['modul_'.$_GET['modul'].'_werte']))
 {
 header('Content-type: image/png');
 $handle=imagecreate($breite,$hoehe);
 $mes_farbe=imagecolorallocate($handle,255,255,255);
 $mes_farbe=imagecolorallocate($handle,255,0,0);
 imagestring($handle,1,1,1,'FEHLER',$mes_farbe);
 imagestring($handle,1,1,15,'Keine Daten',$mes_farbe);
 imagepng($handle);
 imagedestroy($handle);
 exit;
 }
$werte=$_SESSION['modul_'.$_GET['modul'].'_werte'];


$farben=$config_stat_farben;
if(!isset($werte)) $werte[]=0;

$diagramm=imagecreate($breite,$hoehe);

$hoehe--;
$breite--;
$weiss=imagecolorallocate($diagramm, 255, 255, 255);
$schwarz=imagecolorallocate($diagramm, 0, 0, 0);


imagefilledrectangle($diagramm,0,0,$breite,$hoehe,$weiss);

foreach($farben as $nummer => $farbe)
 {
 $rgb=hex2rgb($farbe);
 $farben[$nummer]=imagecolorallocate($diagramm, $rgb[0],$rgb[1],$rgb[2]);
 }

// Kreis zeichnen fuer alte GDlib
imagearc($diagramm, round($breite/2), round($hoehe/2), $breite, $hoehe, 0, 360, $schwarz);

$grauton=0;
$winkel=270;
$teil=0;
rsort($werte);

foreach($werte as $wert)
 {
 $wert=prozent($wert,$_SESSION['modul_'.$_GET['modul'].'_gesamt']);    // prozent

 if(!isset($farben[$teil]))
  {
  $grauton+=20;
  if($grauton>255) $grauton=0;
  $farben[$teil]=imagecolorallocate($diagramm,$grauton,$grauton,$grauton);
  }

 if($winkel>360) $winkel-=360;
 $wert=round(($wert/100)*360);  // grad

 if($wert>0)
  {
  // Tortenstueck zeichnen
  if(is_callable('imagefilledarc'))
   {
   @$ausfuellen=imagefilledarc($diagramm, round($breite/2), round($hoehe/2), $breite, $hoehe, $winkel, $winkel+$wert, $farben[$teil],IMG_ARC_EDGED);
   }
  else
   {
   // Tortenstuecke fuer GDlib <2.0.1 zeichnen
   $radius_x1=round(floor(($breite-2)/2)*cos($winkel/180*M_PI)+round($breite/2));
   $radius_y1=round(floor(($hoehe-2)/2)*sin($winkel/180*M_PI)+round($hoehe/2));
   @imageline($diagramm, round($hoehe/2), round($breite/2), $radius_x1, $radius_y1, $schwarz);
   // Neu ab 1.60 : Fr alte GDLibs wird das Stck per "Flood-Fill"-Pixel gefllt
   /*
        - Errechnen eines Pixels innerhalb des Stcks:
           $fill_x=round(floor(($breite-10)/2)*cos(($winkel+2)/180*M_PI)+round($breite/2));
           $fill_y=round(floor(($hoehe-10)/2)*sin(($winkel+2)/180*M_PI)+round($hoehe/2));
        - Verwenden eines universellen Pixels (Mitte oben):
        */
   $fill_x=floor($breite/2)-2;
   $fill_y=3;
   @imagefilltoborder ($diagramm,$fill_x,$fill_y,$schwarz,$farben[$teil]);
   }
  $winkel+=$wert;
  }
 $teil++;
 }


// Kreis erneut zeichnen (Linienstrke: $glaett_faktor, damit nach Glttung 1px)
for($i=0; $i<$glaett_faktor; $i++)
 imagearc($diagramm, round($breite/2), round($hoehe/2), $breite-$i, $hoehe-$i, 0, 360, $schwarz);

// Kantenglaettung
if(is_callable('imagecreatetruecolor') && is_callable('imagecopyresampled'))
 {
 $diagramm_geglaettet=imagecreatetruecolor($orig_breite, $orig_hoehe);
 imagecopyresampled($diagramm_geglaettet, $diagramm, 0, 0, 0, 0, $orig_breite, $orig_hoehe, $breite+1, $hoehe+1);
 }
else
 {
 // essentielle Funktionen fehlen (alte GDLib) => fallback-lsung
 $diagramm_geglaettet=imagecreate($orig_breite, $orig_hoehe);
 imagecopyresized ($diagramm_geglaettet, $diagramm, 0, 0, 0, 0, $orig_breite, $orig_hoehe, $breite+1, $hoehe+1);
 }


header('Content-type: image/png');
imagepng($diagramm_geglaettet);
imagedestroy($digramm_geglaettet);
imagedestroy($diagramm);

// Hex in RGB umwandeln
function hex2rgb($hex)
 {
 $rgb[0]=hexdec(substr($hex,1,2));
 $rgb[1]=hexdec(substr($hex,3,2));
 $rgb[2]=hexdec(substr($hex,5,2));
 return($rgb);
 }

// Prozent-Funktion
function prozent($teil, $gesamt)
 {
 if($gesamt==0) return 100;
 return @$teil/$gesamt*100;
 }
?>