<?php
/*

>>>>>> CrazyStat <<<<<<
Ein komfortables, umfangreiches und kostenloses Statistik-Script mit oder ohne Counter.

Copyright (C) 2004-2007  Crazy Chrissi

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

E-Mail: christosoft4u AT yahoo DOT de
Web: http://www.christosoft.de
Version: 1.62 (short tags bugfix B included)

*** show_stat.php ***
Funktion:    wertet Logdatei aus
Aufrufbar:   ja
Eingebunden: von index.html (Link)
*/

session_start();
require_once('config.php');
require_once('passwortschutz.php');
require_once('log_funcs.php');  // Log-Funktionen einbinden

// Erhoehe max_execution_time oder nutze fortsetzen
@set_time_limit(150);
$script_complete=false;
@register_shutdown_function('script_ende');
// Erhoehe Ram-Limit
@ini_set('memory_limit', '60M');

function getmicrotime()
 {
 list($usec, $sec) = explode(' ',microtime());
 return ($sec.substr($usec,1,7));
 }
$start=getmicrotime();

// Arrays, die die Module enthalten
$module=Array('hits','wochentage','monate','tage','stunden','browser','dateien','aufloesungen','farbtiefen','systeme','referer','keywords');
$module_limit=Array('browser','dateien','aufloesungen','farbtiefen','systeme','referer','keywords');
$module_diagramme=Array('browser','aufloesungen','systeme');
$module_kalender=Array('wochentage','monate','tage','stunden','browser','dateien','aufloesungen','farbtiefen','systeme','referer','keywords');

// Zeitdaten setzen
$time['stamp']=time();
$time['monat']=date('m');
$time['jahr']=date('Y');
$time['tage']=date('t');

// Alle Module als "not changed" setzen, also unveraenderte Einstellungen (fuer Caching)
foreach($module as $modul) $changed[$modul]=false;

// Lesen der Preset-Einstellungen
if(isset($_POST['Preset_Auswahl']))
 {
 switch ($_POST['Preset_Auswahl'])
  {
  case 'limit1':
   foreach($module_limit as $modul) $_GET[$modul.'_all']=0;
   break;

  case 'limit0':
   foreach($module_limit as $modul) $_GET[$modul.'_all']=1;
   break;

  case 'IP0':
   foreach($module as $modul) $_GET['ip_'.$modul]=0;
   break;

  case 'IP1':
   foreach($module as $modul) $_GET['ip_'.$modul]=1;
   break;

  case 'Balkendiagramme':
   foreach($module_diagramme as $modul) $_GET['diagramm_'.$modul]=1;
   break;

  case 'Tortendiagramme':
   foreach($module_diagramme as $modul) $_GET['diagramm_'.$modul]=0;
   break;

  case 'scroll1':
   $_SESSION['scroll']=true;
   break;

  case 'scroll0':
   $_SESSION['scroll']=false;
   break;

  case 'Default':
   foreach($module as $modul)
    {
    $_GET['ip_'.$modul]=1;
    if($modul!='tage' && $modul!='monate' && $modul!='hits')
     {
     if($_SESSION['kalender_'.$modul.'_aufSpanne']) $changed[$modul]=true;
     $_SESSION['kalender_'.$modul.'_aufSpanne']=false;
     }
    }
   foreach($module_diagramme as $modul) $_GET['diagramm_'.$modul]=0;

   $spanne_start=mktime(0,0,0,$time['monat'],1,$time['jahr']);
   $spanne_ende=mktime(0,0,0,$time['monat']+1,1,$time['jahr'])-1;
   if($_SESSION['kalender_tage_spanne_start']!=$spanne_start || $_SESSION['kalender_tage_spanne_ende']!=$spanne_ende || !$_SESSION['kalender_tage_aufSpanne'])
    {
    $changed['tage']=true;
    $_SESSION['kalender_tage_spanne_start']=$spanne_start;
    $_SESSION['kalender_tage_spanne_ende']=$spanne_ende;
    $_SESSION['kalender_tage_aufSpanne']=true;
    $_SESSION['kalender_tage_titel']=$time['monat'].'/'.$time['jahr'];
    }
   $spanne_start=mktime(0,0,0,1,1,$time['jahr']);
   $spanne_ende=mktime(23,59,59,12,31,$time['jahr']);
   if($_SESSION['kalender_monate_spanne_start']!=$spanne_start || $_SESSION['kalender_monate_spanne_ende']!=$spanne_ende || !$_SESSION['kalender_monate_aufSpanne'])
    {
    $changed['monate']=true;
    $_SESSION['kalender_monate_spanne_start']=$spanne_start;
    $_SESSION['kalender_monate_spanne_ende']=$spanne_ende;
    $_SESSION['kalender_monate_aufSpanne']=true;
    $_SESSION['kalender_monate_titel']=$time['jahr'];
    }

   foreach($module_limit as $modul) $_GET[$modul.'_all']=0;
   $_SESSION['referer_tree']=$config_stat_referer_tree;
   unset($_SESSION['tree']);
   break;

  case 'Diesen Monat':
   $spanne_start=mktime(0,0,0,$time['monat'],1,$time['jahr']);
   $spanne_ende=mktime(0,0,0,$time['monat']+1,1,$time['jahr'])-1;
   foreach($module_kalender as $modul)
    {
    if($_SESSION['kalender_'.$modul.'_spanne_start']!=$spanne_start || $_SESSION['kalender_'.$modul.'_spanne_ende']!=$spanne_ende || !$_SESSION['kalender_'.$modul.'_aufSpanne'])
     {
     $changed[$modul]=true;
     $_SESSION['kalender_'.$modul.'_spanne_start']=$spanne_start;
     $_SESSION['kalender_'.$modul.'_spanne_ende']=$spanne_ende;
     $_SESSION['kalender_'.$modul.'_aufSpanne']=true;
     $_SESSION['kalender_'.$modul.'_titel']=$time['monat'].'/'.$time['jahr'];
     }
    }
   echo '<br>';
   break;

  case 'Dieses Jahr':
   $spanne_start=mktime(0,0,0,1,1,$time['jahr']);
   $spanne_ende=mktime(23,59,59,12,31,$time['jahr']);
   foreach($module_kalender as $modul)
    {
    if(!$_SESSION['kalender_'.$modul.'_aufSpanne'] || $_SESSION['kalender_'.$modul.'_spanne_start']!=$spanne_start || $_SESSION['kalender_'.$modul.'_spanne_ende']!=$spanne_ende)
     {
     $changed[$modul]=true;
     $_SESSION['kalender_'.$modul.'_spanne_start']=$spanne_start;
     $_SESSION['kalender_'.$modul.'_spanne_ende']=$spanne_ende;
     $_SESSION['kalender_'.$modul.'_aufSpanne']=true;
     $_SESSION['kalender_'.$modul.'_titel']='xx/'.$time['jahr'];
     }
    }
   break;
  }
 }

// Baum-Extension-Einstellung
if(isset($_GET['tree']) && $_GET['tree']=='mk') $_SESSION['tree']='mk';
elseif(isset($_GET['tree'])) $_SESSION['tree']='ajax';
elseif(!isset($_SESSION['tree']))
 {
 if($config_stat_tree=='auto' && isset($_REQUEST['ajax']) && $_REQUEST['ajax']) $_SESSION['tree']='ajax';
 elseif($config_stat_tree=='auto') $_SESSION['tree']='mk';
 else $_SESSION['tree']=$config_stat_tree;
 }

// Setze Session-ID-Konstante
define('SID',session_name().'='.session_id());

echo '<?xml version="1.0" encoding="iso-8859-1"?>'."\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>CrazyStat</title>
  <link href="style.css" rel="stylesheet" type="text/css" />
<?php if(is_file('extensions/mktree.css') && is_file('extensions/mktree.js') && $_SESSION['tree']=='mk') { $mktree=true; ?>
  <link href="extensions/mktree.css" rel="stylesheet" type="text/css" />
  <script type="text/javascript" src="extensions/mktree.js"></script>
<?php } else $mktree=false;
if(is_file('extensions/ajaxTree/ajaxTree.js') && is_file('extensions/ajaxTree/ajaxTree.css') && $_SESSION['tree']=='ajax') { $ajaxTree=true; ?>
  <link href="extensions/ajaxTree/ajaxTree.css" rel="stylesheet" type="text/css" />
  <script type="text/javascript" src="extensions/ajaxTree/ajaxTree.js"></script>
  <script type="text/javascript"> window.onload=checkAjax; </script>
<?php } else $ajaxTree=false; ?>
  <meta name="generator" content="WebCraft v1.6.8 [http://pr0g.net]" />
  <meta http-equiv="expires" content="0" />
  <script type="text/javascript" language="javascript">
  function waitmessage()
   {
   document.getElementById('waitbox').style.display='block';
   document.getElementById('body').style.cursor='wait';
   }
  </script>
 </head>
 <body id="body" style="padding-left:0px;">
  <h1 style="margin-left:4px"><img src="crazystat.gif" alt="CrazyStat" title="" width="146" height="35" /></h1>
  <div class="menue">
   <form method="post" action="show_stat.php">
    <span class="copyright">Copyright 2004 - 2007 <a href="http://www.christosoft.de" class="copyright" target="_blank">Crazy Chrissi</a> <span class="version">- Version 1.62</span></span>
    <input type="hidden" name="<?php echo session_name(); ?>" value="<?php echo session_id(); ?>" />
    <select class="presets" name="Preset_Auswahl" size="1" onchange="if(this.form.Preset_Auswahl.options[this.form.Preset_Auswahl.selectedIndex].value!='Presets') { waitmessage(); this.form.submit(); }">
     <option class="presetsHead" value="Presets"> &gt;&gt; Presets &lt;&lt; </option>
     <option value="Default">Default</option>
     <option value="IP1">IP-Sperren an</option>
     <option value="IP0">IP-Sperren aus</option>
     <option value="Tortendiagramme">Tortendiagramme</option>
     <option value="Balkendiagramme">Balkendiagramme</option>
     <option value="Dieses Jahr">Dieses Jahr</option>
     <option value="Diesen Monat">Diesen Monat</option>
     <option value="limit0">Alle anzeigen (all)</option>
     <option value="limit1">Begrenzt anzeigen (limit)</option>
     <option value="scroll1">Modul-Scrollbalken ein</option>
     <option value="scroll0">Modul-Scrollbalken aus</option>
    </select>
    <noscript>
     <input type="submit" value="Go" />
    </noscript>
    <input type="hidden" name="ajax" value="0" id="ajaxInput" />
<?php if($config_stat_default_file_cache) { ?>
    <a href="show_stat.php?clearcache=true&amp;reload=true&amp;<?php echo SID; ?>" onclick="waitmessage();">Cache l&ouml;schen</a> |
<?php } if($config_stat_cache) { ?>
    <a href="show_stat.php?reload=true&amp;<?php echo SID; ?>" onclick="waitmessage();">Alle aktualisieren</a> |
<?php } ?>
    <a href="logs.php?<?php echo SID; ?>" target="logs">Logs</a>
<?php if($config_stat_passwortschutz) { ?>|
    <a href="show_stat.php?logout=true&amp;<?php echo SID; ?>">Logout</a>
<?php } ?>
   </form>
  </div>

<?php
$logdatei_name=get_first_log();
if(!is_file($logdatei_name)) die('<h2>Fehler</h2><p class="meldung">Die Datei "'.$logdatei_name.'" konnte nicht erstellt werden. Bitte &uuml;berpr&uuml;fen Sie "config.php" und die Rechte des Ordners in dem die Logdateien liegen bzw. ob der Ordner &uuml;berhaupt existiert.</p>');



// Hits, Wochentage, Stunden, Monate und Tage auf 0 setzen

// Wochentage
if($config_stat_wochentage_sonntag_erst) $wochentage[0]=0;
for($i=1;$i<=6;$i++) $wochentage[$i]=0;
if(!$config_stat_wochentage_sonntag_erst) $wochentage[7]=0;

// Hits
$hits['gesamt']=0;
$hits['gesamt_ip']=0;
$hits['diesen_monat']=0;
$hits['letzten_monat']=0;
$hits['user_online']=0;
$hits['max']=0;
// Stunden
for($i=0;$i<=23;$i++) $stunden[$i]=0;
// Monate
for($i=1;$i<=12;$i++) $monate[$i]=0;
// Tage
for($i=1;$i<=$time['tage'];$i++) $tage[$i]=0;

// Lesen der Scroll-Einstellung
if(isset($_SESSION['scroll'])) $config_stat_scroll=$_SESSION['scroll'];

// Lesen der IP-Einstellungen
foreach($module as $modul)
 {
 if(!isset($_SESSION['ip_'.$modul])) $_SESSION['ip_'.$modul]=1;
 if(isset($_GET['ip_'.$modul]))
  {
  if($_SESSION['ip_'.$modul]!=$_GET['ip_'.$modul]) $changed[$modul]=true;
  @$_SESSION['ip_'.$modul]=$_GET['ip_'.$modul];
  }
 }

foreach($module as $modul) @$ipE[$modul]=$_SESSION['ip_'.$modul];

foreach($ipE as $schluessel => $wert)
 {
 if(!isset($ipE[$schluessel])) $wert=1;
 if($wert==0)
  {
  $ipEN[$schluessel]='aus';
  $ipENG[$schluessel]='an';
  $ipEG[$schluessel]=1;
  }
 else
  {
  $ipE[$schluessel]=1;
  $ipEN[$schluessel]='an';
  $ipENG[$schluessel]='aus';
  $ipEG[$schluessel]=0;
  }
 }

// Lesen der Diagramm-Einstellungen

foreach($module_diagramme as $modul)
 {
 if(isset($_GET['diagramm_'.$modul])) @$_SESSION['diagramm_'.$modul]=$_GET['diagramm_'.$modul];
 @$diagrammE[$modul]=$_SESSION['diagramm_'.$modul];
 }

foreach($diagrammE as $schluessel => $wert)
 {
 if(!isset($diagrammE[$schluessel])) $wert=0;
 if($wert==0)
  {
  $diagrammEN[$schluessel]='Torten';
  $diagrammENG[$schluessel]='Balken';
  $diagrammEG[$schluessel]=1;
  }
 else
  {
  $diagrammE[$schluessel]=1;
  $diagrammEN[$schluessel]='Balken';
  $diagrammENG[$schluessel]='Torten';
  $diagrammEG[$schluessel]=0;
  }
 }

// Lesen der Limit Einstellungen

foreach($module_limit as $modul)
 {
 if(isset($_GET[$modul.'_all'])) $_SESSION[$modul.'_all']=$_GET[$modul.'_all'];
 elseif(!isset($_SESSION[$modul.'_all'])) $_SESSION[$modul.'_all']=0;
 }

// Lesen der Referer-Tree-Einstellung
if(isset($_GET['referer_tree']))
 {
 if($_GET['referer_tree']=='1') $_SESSION['referer_tree']=true;
 elseif($_GET['referer_tree']=='0') $_SESSION['referer_tree']=false;
 }
elseif(!isset($_SESSION['referer_tree'])) $_SESSION['referer_tree']=$config_stat_referer_tree;

// Setzen von Kalender-Einstellungen, falls leer

if((!isset($_SESSION['kalender_tage_spanne_start']) || !isset($_SESSION['kalender_tage_spanne_ende'])) && !isset($_SESSION['kalender_tage_aufSpanne']))
 {
 $_SESSION['kalender_tage_spanne_start']=mktime(0,0,0,$time['monat'],1,$time['jahr']);
 $_SESSION['kalender_tage_spanne_ende']=mktime(0,0,0,$time['monat']+1,1,$time['jahr'])-1;
 $_SESSION['kalender_tage_aufSpanne']=true;
 $_SESSION['kalender_tage_titel']=$time['monat'].'/'.$time['jahr'];
 }
if((!isset($_SESSION['kalender_monate_spanne_start']) || !isset($_SESSION['kalender_monate_spanne_ende'])) && !isset($_SESSION['kalender_monate_aufSpanne']))
 {
 $_SESSION['kalender_monate_spanne_start']=mktime(0,0,0,1,1,$time['jahr']);
 $_SESSION['kalender_monate_spanne_ende']=mktime(23,59,59,12,31,$time['jahr']);
 $_SESSION['kalender_monate_aufSpanne']=true;
 $_SESSION['kalender_monate_titel']=$time['jahr'];
 }
foreach($module_kalender as $modul)
 {
 if(!isset($_SESSION['kalender_'.$modul.'_aufSpanne']))
  {
  $_SESSION['kalender_'.$modul.'_aufSpanne']=false;
  $_SESSION['kalender_'.$modul.'_spanne_start']=0;
  $_SESSION['kalender_'.$modul.'_spanne_ende']=0;
  }
 }

// Von kalender.php uebergebene oder durch "aktualisieren"-Button ausgeloeste changed-daten auslesen
if(isset($_GET['changed']) && isset($modul[$_GET['changed']])) $changed[$_GET['changed']]=true;

// Cache auslesen
$all_cached=true;
foreach ($module as $modul)
 {
 if($config_stat_cache && isset($_SESSION['modul_'.$modul.'_werte']) && !$changed[$modul] && (!isset($_GET['reload']) || $_GET['reload']!='true'))
  {
  $$modul=$_SESSION['modul_'.$modul.'_werte'];
  $cached[$modul]=true;
  }
 else
  {
  $cached[$modul]=false;
  $all_cached=false;
  }
 }

// Fortsezen?
if(isset($_GET['goon']) && $_GET['goon'])
 {
 $vars_to_load=array_merge(array('pos','letzte_daten','logdatei_name','hits_user_tag','ips','ips_dateien','ips_online'),$module);
 foreach($vars_to_load as $var) $$var=$_SESSION['goon_'.$var];
 unset($vars_to_load);
 $handle=fopen($logdatei_name,'r');
 fseek($handle,$_SESSION['goon_pos']);
 }
else $handle=fopen($logdatei_name,'r');

$default_all_cached=false;

// starten des auslesen
if(!$all_cached)
 {
 $user_online_check_val=$time['stamp']-60*$config_stat_user_online;   // IP-Sperren-vergleichswert
 // Robotsdatei einlesen
 $robots=file('keywords/robots.txt');
 // Browserdatei einlesen
 $browsers=file('keywords/browser.txt');
 $i=0;
 while(isset($browsers[$i]))
  {
  if(strstr($browsers[$i],'='))
   {
   $browser_string[$i]=trim(substr($browsers[$i],0,strpos($browsers[$i],'=')));
   $browser_name[$i]=trim(substr($browsers[$i],strpos($browsers[$i],'=')+1));
   }
  else
   {
   $browser_string[$i]=trim($browsers[$i]);
   $browser_name[$i]=trim($browsers[$i]);
   }
  $i++;
  }
 $browser_anz=$i-1;
 // Systeme-datei einlesen
 $systems=file('keywords/systeme.txt');
 $i=0;
 while(isset($systems[$i]))
  {
  if(strstr($systems[$i],'='))
   {
   $system_string[$i]=trim(substr($systems[$i],0,strpos($systems[$i],'=')));
   $system_name[$i]=trim(substr($systems[$i],strpos($systems[$i],'=')+1));
   }
  else
   {
   $system_string[$i]=trim($systems[$i]);
   $system_name[$i]=trim($systems[$i]);
   }
  $i++;
  }
 $system_anz=$i-1;
 // Query-Regex-Datei einlesen
 $queryregex=file('keywords/queryregex.txt');
 foreach($queryregex as $regex) $queryregex_str[trim(substr($regex,0,strpos($regex,"\t")))]=trim(substr($regex,strpos($regex,"\t")+1));

 
 $fertig=false;

 $diesen_monat_start=mktime(0,0,0,$time['monat'],1,$time['jahr']);
 $diesen_monat_ende=mktime(0,0,0,$time['monat']+1,1,$time['jahr'])-1;
 $letzten_monat_start=mktime(0,0,0,$time['monat']-1,1,$time['jahr']);
 $letzten_monat_ende=mktime(0,0,0,$time['monat'],1,$time['jahr'])-1;

 // Default-File-Cache
 if($config_stat_default_file_cache)
  {
  // checkDefault
  $default=true;
  foreach($module as $modul)
   {
   if($_SESSION['ip_'.$modul]!=1 || (($modul!='tage' && $modul!='monate' && $modul!='hits') && $_SESSION['kalender_'.$modul.'_aufSpanne']!=false))
    {
    $default=false;
    break;
    }
   }
  if($_SESSION['kalender_tage_spanne_start']!=mktime(0,0,0,$time['monat'],1,$time['jahr']) || $_SESSION['kalender_tage_spanne_ende']!=(mktime(0,0,0,$time['monat']+1,1,$time['jahr'])-1) || $_SESSION['kalender_tage_aufSpanne']!=true || $_SESSION['kalender_monate_spanne_start']!=mktime(0,0,0,1,1,$time['jahr']) || $_SESSION['kalender_monate_spanne_ende']!=mktime(23,59,59,12,31,$time['jahr']) || $_SESSION['kalender_monate_aufSpanne']!=true) $default=false;

  $default_filename='default_'.md5($config_logdatei_ordner).'.php';
  }
 // include Cache
 if($config_stat_default_file_cache && $default && is_file('cache/'.$default_filename) &&  (!isset($_GET['clearcache']) || $_GET['clearcache']!='true'))
  {
  require_once('cache/'.$default_filename);
  if(isset($save_monat) && isset($save_jahr) && ($save_monat!=$time['monat'] ||  $save_jahr!=$time['jahr']))    // Monatswechsel
   {
   $tage=array();
   for($i=1;$i<=$time['tage'];$i++) $tage[$i]=0;
   if($save_jahr!=$time['jahr']) // jahreswechsel
    {
    $monate=array();
    for($i=1;$i<=12;$i++) $monate[$i]=0;
    }
   if($save_monat+0==$time['monat']-1 || ($save_monat=='12' && $time['monat']=='01')) $hits['letzten_monat']=$hits['diesen_monat'];
   else $hits['letzten_monat']=0;
   $hits['diesen_monat']=0;
   }
  // user noch online?
  if(isset($usr_on_stamp))
   {
   foreach($usr_on_stamp as $ip=>$stamp)
    {
    if($stamp<$user_online_check_val) unset($usr_on_stamp[$ip]);
    else $ips_online[$ip]=floor($stamp/60/$config_stat_user_online);
    }
   $hits['user_online']=count($usr_on_stamp);
   }
  else $hits['user_online']=0;
  $handle=fopen($logdatei_name,'r');
  if(isset($pos)) fseek($handle,$pos);
  if(ftell($handle)==filesize($logdatei_name)) // Alles bereits im Cache
   {
   $fertig=true;
   $default_all_cached=true;
   }
  }

// Starte Auswertung
 while(!$fertig)
  {
  if(!$config_logdatei_maxsize) $zeile=fgets($handle); // aus performance-gruenden wird ohne splitten auf eine funktion verzichtet
  else @$zeile=get_next_line();
  
  if($zeile===false) break;
  $daten=explode('#', $zeile);
  if(!is_array($daten) || count($daten)<5) continue;

  if($config_log_ver==1.5) $daten=convert_log_data($daten);  // 1.5 logs in 1.6 konvertieren
  elseif($config_log_ver==1.6 && $config_log_shrinked) // "kompression"
   {
   foreach($daten as $id=>$data)
    {
    $data=trim($data);
    if($data!='^') $letzte_daten[$id]=$data;
    else $daten[$id]=$letzte_daten[$id];
    }
   }
  foreach($robots as $robot)
   {
   if(strpos($daten[4],trim($robot))!==false) { continue 2; }
   }
  $timecontrol=floor($daten[1]/60/$config_ip_sperre_zeit);

  // Gesamthits
  if(!$cached['hits']) $hits['gesamt']++;

  // Dateien
  if(!$cached['dateien'])
   {
   if(isset($config_stat_dateien_delete) && is_array($config_stat_dateien_delete)) foreach($config_stat_dateien_delete as $delete_this) $daten[3]=str_replace($delete_this,'',$daten[3]);
   if(isset($config_stat_dateien_replace) && is_array($config_stat_dateien_replace)) foreach($config_stat_dateien_replace as $from=>$to) $daten[3]=str_replace($from,$to,$daten[3]);
   if(isset($config_stat_dateien_preg_replace) && is_array($config_stat_dateien_preg_replace)) foreach($config_stat_dateien_preg_replace as $from=>$to) $daten[3]=preg_replace($from,$to,$daten[3]);

   if(($ipE['dateien']==0 || (!isset($ips_dateien[$daten[2].'#'.$daten[3]]) || $ips_dateien[$daten[2].'#'.$daten[3]]!=$timecontrol)) && (!$_SESSION['kalender_dateien_aufSpanne'] || ($_SESSION['kalender_dateien_spanne_start']<=$daten[1] && $_SESSION['kalender_dateien_spanne_ende']>$daten[1])))
    {
    @$dateien[$daten[3]]++;
    }
   @$ips_dateien[$daten[2].'#'.$daten[3]]=$timecontrol;
   }
  // User online
  if(!$cached['hits'] && $daten[1]>=$user_online_check_val)
   {
   if(!isset($ips_online[$daten[2]]) || $ips_online[$daten[2]]!=floor($daten[1]/60/$config_stat_user_online))
    {
    $hits['user_online']++;
    // Fuer Default-Cache
    $usr_on_stamp[$daten[2]]=$daten[1];
    }
   @$ips_online[$daten[2]]=floor($daten[1]/60/$config_stat_user_online);
   }

  // Globale IP-Sperre: Greift wenn alle IP-Sperren an sind (default) -> bessere Performance
  if(isset($ips[$daten[2]]) && $ips[$daten[2]]==$timecontrol) $reload=true; else $reload=false;
  @$ips[$daten[2]]=$timecontrol;
  $ip_sperre=true; foreach($ipE as $ip) if($ip==0) $ip_sperre=false;
  if(!$reload || !$ip_sperre)
   {
   // Hits
   if(!$cached['hits'])
    {
    // Gesamthits mit ip-sperre
    if(!$reload) $hits['gesamt_ip']++;
    // Hits diesen Monat mit ip-sperre
    if(!$reload && $diesen_monat_start<=$daten[1] && $diesen_monat_ende>$daten[1]) $hits['diesen_monat']++;
    // Hits letzten Monat mit ip-sperre
    if(!$reload && $letzten_monat_start<=$daten[1] && $letzten_monat_ende>$daten[1]) $hits['letzten_monat']++;
    }
   if($config_log_ver!=1.5)
    {
    $datum=getDateFast($daten[1]);
    $daten['w']=$datum[4];
    $daten['H']=$datum[3];
    $daten['d']=$datum[2];
    $daten['m']=$datum[1];
    $daten['Y']=$datum[0];
    unset($datum);
    }
    

   // User / Tag fuer Max & Durchschnitt
   if(!$reload)
    {
    @$hits_user_tag[$daten['d'].'.'.$daten['m'].'.'.$daten['Y']]++;
    }
   //Wochentage
   if(!$cached['wochentage'])
    {
    if((!$reload || $ipE['wochentage']==0) && (!$_SESSION['kalender_wochentage_aufSpanne'] || ($_SESSION['kalender_wochentage_spanne_start']<=$daten[1] && $_SESSION['kalender_wochentage_spanne_ende']>$daten[1])))
     {
     if(!$config_stat_wochentage_sonntag_erst && $daten['w']==0) $daten['w']=7;
     $wochentage[$daten['w']]++;
     }
    }
   // Stunden
   if(!$cached['stunden'])
    {
    if((!$reload || $ipE['stunden']==0) && (!$_SESSION['kalender_stunden_aufSpanne'] || ($_SESSION['kalender_stunden_spanne_start']<=$daten[1] && $_SESSION['kalender_stunden_spanne_ende']>$daten[1])))
     {
     $stunden[intval($daten['H'])]++;
     }
    }
   // Monate
   if(!$cached['monate'])
    {
    if((!$reload || $ipE['monate']==0) && (!$_SESSION['kalender_monate_aufSpanne'] || ($_SESSION['kalender_monate_spanne_start']<=$daten[1] && $_SESSION['kalender_monate_spanne_ende']>$daten[1])))
     {
     $monate[intval($daten['m'])]++;
     }
    }
   // Tage
   if(!$cached['tage'])
    {
    if((!$reload || $ipE['tage']==0) && (!$_SESSION['kalender_tage_aufSpanne'] || ($_SESSION['kalender_tage_spanne_start']<=$daten[1] && $_SESSION['kalender_tage_spanne_ende']>$daten[1])))
     {
     $tage[intval($daten['d'])]++;
     }
    }
   // Betriebssystem
   if(!$cached['systeme'])
    {
    if((!$reload || $ipE['systeme']==0) && (!$_SESSION['kalender_systeme_aufSpanne'] || ($_SESSION['kalender_systeme_spanne_start']<=$daten[1] && $_SESSION['kalender_systeme_spanne_ende']>$daten[1])))
     {
     $i=0; $match=false;
     while($i<=$system_anz && !$match)  // teste alle Systeme durch bis gefunden
      {
      if(empty($system_name[$i]))
       {
       $match=true;
       break;
       }
      if(strpos($daten[4],$system_string[$i])!==false)
       {
       @$systeme[$system_name[$i]]++;
       $match=true;
       }
      $i++;
      }
     if(!$match) @$systeme['Sonstige']++;
     }
    }
   // Browser
   if(!$cached['browser'])
    {
    if((!$reload || $ipE['browser']==0) && (!$_SESSION['kalender_browser_aufSpanne'] || ($_SESSION['kalender_browser_spanne_start']<=$daten[1] && $_SESSION['kalender_browser_spanne_ende']>$daten[1])))
     {
     $i=0; $match=false;
     while($i<=$browser_anz && !$match)  // teste alle Browser durch bis gefunden
      {
      if(empty($browser_name[$i]))
       {
       $match=true;
       break;
       }
      if(strpos($daten[4],$browser_string[$i])!==false)
       {
       @$browser[$browser_name[$i]]++;
       $match=true;
       }
      $i++;
      }
     if(!$match) @$browser['Sonstige']++;
     }
    }
   // Aufloesung
   if(!$cached['aufloesungen'])
    {
    if((!$reload || $ipE['aufloesungen']==0) && (!$_SESSION['kalender_aufloesungen_aufSpanne'] || ($_SESSION['kalender_aufloesungen_spanne_start']<=$daten[1] && $_SESSION['kalender_aufloesungen_spanne_ende']>$daten[1])))
     {
     if(empty($daten[5])) $daten[5]='Nicht gespeichert';
     @$aufloesungen[trim($daten[5])]++;
     }
    }
   // Farbtiefe
   if(!$cached['farbtiefen'] && isset($daten[7]))
    {
    $daten[7]=trim($daten[7]);
    if((!$reload || $ipE['farbtiefen']==0) && (!$_SESSION['kalender_farbtiefen_aufSpanne'] || ($_SESSION['kalender_farbtiefen_spanne_start']<=$daten[1] && $_SESSION['kalender_farbtiefen_spanne_ende']>$daten[1])))
     {
     if(empty($daten[7]) || !is_numeric($daten[7]) || $daten[7]>=100 || $daten[7]<0)
      {
      if($config_stat_farbtiefen_unsaved) @$farbtiefen['Nicht gespeichert']++;
      }
     else
      {
      @$farbtiefen[$daten[7]]++;
      }
     }
    }
   // Referer
   if(!$cached['referer'])
    {
    if(isset($config_stat_referer_replace) && is_array($config_stat_referer_replace)) foreach($config_stat_referer_replace as $from=>$to) @$daten[6]=str_replace($from,$to,$daten[6]);

    if($config_stat_limit['referer']!=0 && (!$reload || $ipE['referer']==0) && (!$_SESSION['kalender_referer_aufSpanne'] || ($_SESSION['kalender_referer_spanne_start']<=$daten[1] && $_SESSION['kalender_referer_spanne_ende']>$daten[1])))
     {
     if(!isset($daten[6])) $daten[6]='';
     $daten[6]=trim($daten[6]);
     if(!empty($daten[6]) || $config_stat_referer_leer)
      {
      // referer ignorieren
      $ignore=false;
      if(is_array($config_stat_referer_ignore))
       {
       foreach($config_stat_referer_ignore as $page) if(strpos($daten[6], $page)===0) $ignore=true;
       }
      elseif(is_string($config_stat_referer_ignore)) if(strpos($daten[6], $page)===0) $ignore=true;
      if(!$ignore) @$referer[$daten[6]]++;
      }
     }
    }
   // Keywords
   if(!$cached['keywords'])
    {
    if($config_stat_limit['keywords']!=0 && (!$reload || $ipE['keywords']==0) && (!$_SESSION['kalender_keywords_aufSpanne'] || ($_SESSION['kalender_keywords_spanne_start']<=$daten[1] && $_SESSION['kalender_keywords_spanne_ende']>$daten[1])))
     {
     if(!isset($daten[6])) $daten[6]='';
     else
      {
      foreach($queryregex_str as $regex=>$key)
       {
       if(preg_match($regex,$daten[6],$keyword))
        {
        $keyword[$key]=urldecode($keyword[$key]);
        // Sortiere die keywords
        $keyword[$key]=explode(' ',$keyword[$key]);
        sort($keyword[$key]);
        $keyword[$key]=implode(' ',$keyword[$key]);
        // kuerzen
        if(strlen($keyword[$key])>35)
         $keyword[$key]='<span title="'.htmlentities($keyword[$key]).'">'.htmlentities(substr($keyword[$key],0,30)).'[...]</span>';
        else $keyword[$key]=htmlentities($keyword[$key]);
        @$keywords[$keyword[$key]]++;
        break;
        }
       }
      }
     }
    }
    
   }
  }

 // Aktualisiere counter.log
 $counterfile_path=$config_logdatei_ordner.'/'.$config_count_file;
 @$counterfile_handle=fopen($counterfile_path,'r+');
 if($counterfile_handle===false)
  {
  echo 'Counter-Logdatei konnte nicht gelesen werden. Versuche neue zu erstellen.';
  @$counterfile_handle=fopen($counterfile_path,'w');
  if($counterfile_handle===false) echo ' Erstellen fehlgeschlagen (Rechte?). Dies stellt keinen Datenverlust dar. Siehe FAQ.';
  else
   {
   fwrite($counterfile_handle,"0\n".$hits['gesamt_ip']."\n".$hits['gesamt']);
   fclose($counterfile_handle);
   echo ' Erstellen erfolgreich. Dies stellt kein Problem dar, es sind keine Daten verloren gegangen.';
   }
  }
 else
  {
  fgets($counterfile_handle); // 1. Zeile (readpos) unangetastet lassen
  fwrite($counterfile_handle,$hits['gesamt_ip']."\n".$hits['gesamt']);
  fclose($counterfile_handle);
  }
 }

// Hits max
if(isset($hits_user_tag))
 {
 arsort($hits_user_tag);
 foreach($hits_user_tag as $tag => $int)
  {
  $hits['max_tag']=$tag;
  $hits['max']=$int;
  break;
  }
 }

// Durchschnitt User/Tag
if(isset($hits_user_tag))
 {
 $hits_user_anz_tage=count($hits_user_tag);
 $hits['durchschnitt']=str_replace('.',',',round($hits['gesamt_ip']/$hits_user_anz_tage,2));
 }
 
// Hits pro User
@$hits['proUser']=str_replace('.',',',round($hits['gesamt']/$hits['gesamt_ip'],2));

// Maximal-Werte
foreach($module as $modul)
 {
 if(isset($$modul) && ($config_stat_lange_balken || !in_array($modul,$module_limit)))
  {
  foreach($$modul as $eintrag=>$wert)
   {
   if(@$max[$modul]<$wert)
    {
    $max[$modul]=$wert;
    if(!in_array($modul,$module_limit)) $max[$modul.'_name']=$eintrag;
    }
   }
  }
 }


// Ende der Auswertung.

// Default-FileCache: Ergebnisse cachen
if($config_stat_default_file_cache && !$all_cached && $default && !$default_all_cached) save_results('dfc');

// Ausgeben der Ergebnisse
?>
<!-- Start Module-->
<table width="100%">
 <tr>
  <td class="spalte">
   <!-- Start Modul Hits -->
   <table class="modul">
    <tr><th colspan="3" class="modul"><a href="show_stat.php?changed=hits&amp;<?php echo SID; ?>" onclick="waitmessage();"><img src="reload.gif" align="right" title="Modul aktualisieren" alt="Aktualis." width="13" height="16" /></a>Hits</th></tr>
    <tr><td>Gesamt-Hits:</td><td><?php echo $hits['gesamt']; ?></td><td><img src="ip0.gif" alt="ohne IP-Sperre" /></td></tr>
    <tr><td>Gesamt-Hits:</td><td><?php echo $hits['gesamt_ip']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>Hits diesen Monat:</td><td><?php echo $hits['diesen_monat']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>Hits letzten Monat:</td><td><?php echo $hits['letzten_monat']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>User online:</td><td><?php echo $hits['user_online']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>Maximum am <?php echo @$hits['max_tag']; ?>:</td><td><?php echo $hits['max']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>Durchschnitt Hits/Tag</td><td><?php echo @$hits['durchschnitt']; ?></td><td><img src="ip1.gif" alt="mit IP-Sperre" /></td></tr>
    <tr><td>Hits/User</td><td><?php echo $hits['proUser']; ?></td><td><img src="ip0.gif" alt="Ohne IP-Sperre" /></td></tr>
   </table>
   <!-- Ende Modul Hits -->
<?php

$_SESSION['modul_hits_werte']=$hits;

// Wochentage
ausgabe('wochentage', 'Wochentag');

// Monate
ausgabe('monate', 'Monat');
echo '  </td>'."\n".'  <td class="spalte" style="width:16%">'."\n";

// Tage
ausgabe('tage','Tag');
echo '  </td>'."\n".'  <td class="spalte">'."\n";

// Stunden
ausgabe('stunden','Stunde');

// Browser
ausgabe('browser','Browser');
echo '  </td>'."\n".'  <td class="spalte" style="width:31%">'."\n";

// Dateien
ausgabe('dateien','Datei');

// Aufloesungen
ausgabe('aufloesungen','Aufl&ouml;sung');

// Farbtiefe
ausgabe('farbtiefen','Farbtiefe');

// System
ausgabe('systeme','System');
?>
  </td>
 </tr>
 <tr>
  <td colspan="3" style="vertical-align:top;">
<?php
// Referer
ausgabe('referer','Referer');
?>
  </td>
  <td class="spalte">
<?php
// Keywords
ausgabe('keywords','Suchbegriff');
?>
  </td>
 </tr>
</table>
<!-- Ende Module-->

<!-- Start Waitbox -->
<div id="waitbox">
 <table style="width:100%; text-align:center">
  <tr><th class="modul">Bitte warten...</th></tr>
  <tr>
   <td>
    <p>Die von Ihnen gew&uuml;nschte Aktion ben&ouml;tigt einen Moment. Eventuell muss die Statistik neu ausgewertet werden, was einige Zeit in Anspruch nimmt.</p>
    <p><img src="wait.gif" alt="" style="margin-right:10px;" />Bitte warten ...</p>
   </td>
  </tr>
 </table>
</div>
<!-- Ende Waitbox -->

<?php
// Konsole, die die Buttons neben dem Modul-namen enthaellt
function konsole($modul)
 {
 global $ipE, $ipEG, $ipEN, $ipENG, $diagrammE, $diagrammEG, $diagrammEN, $diagrammENG, $config_stat_limit, $config_stat_cache, $mktree, $ajaxTree, $module_limit, $module_diagramme, $$modul;
 $konsolenzeile='<a href="kalender.php?modul='.$modul.'&amp;'.SID."\" onclick=\"kalender=window.open('kalender.php?modul=".$modul."&amp;".SID."','kalender','height=480, width=200'); kalender.focus(); return false;\"><img src=\"kalender.gif\" width=\"16\" height=\"16\" alt=\"Zeitraum\" title=\"Zeitraum bestimmen\" align=\"right\" /></a>";
 if($config_stat_cache)
  {
  $konsolenzeile.='<a href="show_stat.php?'.SID.'&amp;changed='.$modul.'" onclick="waitmessage();"><img src="reload.gif" align="right" title="Modul aktualisieren" alt="Aktualis." width="13" height="16" /></a>';
  }
 $konsolenzeile.='<a href="show_stat.php?'.SID.'&amp;ip_'.$modul.'='.$ipEG[$modul].'" onclick="waitmessage();"><img src="ip'.$ipE[$modul].'.gif" alt="IP-Sperre '.$ipENG[$modul].'" title="IP-Sperre '.$ipEN[$modul].'. Klicken um '.$ipENG[$modul].'zuschalten." width="16" height="16" align="right" /></a>';
 if(in_array($modul,$module_diagramme)) $konsolenzeile.="<a href=\"show_stat.php?".SID."&amp;diagramm_".$modul."=".$diagrammEG[$modul]."\" onclick=\"waitmessage();\"><img src=\"chart.gif\" alt=\"".$diagrammENG[$modul]."diagramm\" title=\"".$diagrammEN[$modul]."diagramm. Klicken um zu ".$diagrammENG[$modul]."diagramm zu wechseln.\" width=\"16\" height=\"16\" align=\"right\" /></a>";
 if(in_array($modul,$module_limit) && (count($$modul)>$config_stat_limit[$modul] || $modul=='referer'))
  {
  if(!isset($_SESSION[$modul."_all"]) || $_SESSION[$modul."_all"]==0) $konsolenzeile.="<a href='show_stat.php?".SID."&amp;".$modul."_all=1' onclick=\"waitmessage();\"><img src='all.gif' align='right' alt='Alle' title='Alle anzeigen' /></a>";
  else $konsolenzeile.="<a href='show_stat.php?".SID."&amp;".$modul."_all=0' onclick=\"waitmessage();\"><img src='limit.gif' align='right' alt='Limit' title='Nur ".$config_stat_limit[$modul]." anzeigen' /></a>";
  }
 if($modul=='referer')
  {
  if(!$_SESSION['referer_tree']) $konsolenzeile.='<a href="show_stat.php?referer_tree=1&amp;tree=mk&amp;'.SID.'"><img src="extensions/hosts.gif" align="right" alt="Baumansicht an" title="Baumansicht anschalten, Referer nach Hosts ordnen" /></a>';
  else
   $konsolenzeile.=($ajaxTree? '<a href="show_stat.php?referer_tree=0&amp;'.SID.'"><img src="extensions/pages.gif" align="right" alt="Baumansicht aus" title="Baumansicht abschalten, alle Seiten einzeln listen" /></a>'
                           : '<a href="show_stat.php?referer_tree=1&amp;tree=ajax&amp;'.SID.'"><img src="extensions/hosts.gif" align="right" alt="Andere Baum-Extension" title="Andere Baum-Extension" /></a>')
                           . '<a href="nojs.html" onclick="collapseTree('.($ajaxTree? '':'\'tree1\'').'); return false;"><img src="extensions/minus.gif" align="right" alt="Alle verbergen" title="Alle Referer verbergen" /></a> <a href="nojs.html" onclick="expandTree('.($ajaxTree? '1':'\'tree1\'').'); return false;"><img src="extensions/plus.gif" align="right" alt="Alle anzeigen" title="Alle Referer anzeigen" /></a>';
  }
 return $konsolenzeile;
 }
 
// Ausgabe der Module
function ausgabe($modul, $name)
 {
 global $$modul, $config_stat_max_style, $config_stat_limit, $config_stat_farben, $config_stat_scroll, $diagrammE, $max, $config_stat_referer_ignore, $config_stat_lange_balken, $config_stat_scroll_middle, $config_stat_scroll_right, $config_stat_dateien_maxlength, $mktree, $ajaxTree, $module_limit, $module_diagramme, $config_stat_balken_laenge, $config_stat_kreisdiagramm_groesse;
 echo '   <!-- Start Modul '.ucfirst($modul).' -->'."\n";
 if(!isset($config_stat_limit[$modul]) || $config_stat_limit[$modul]!=0)
  {
  if(in_array($modul,$module_limit))
   {
   if(!isset($$modul) || !is_array($$modul)) $$modul=array('Keine Zugriffe'=>0);
   else arsort($$modul);
   }
   
  $gesamt=0;
  if($modul!='referer') { if(isset($$modul)) foreach($$modul as $wert) { $gesamt=$gesamt+$wert; } }
  if($config_stat_lange_balken && isset($max[$modul])) $gesamt2=$max[$modul];

  if($_SESSION['kalender_'.$modul.'_aufSpanne'])
   {
   if(isset($_SESSION['kalender_'.$modul.'_titel'])) $zeitabschnitt=$_SESSION['kalender_'.$modul.'_titel'];
   else
    {
    $zeitabschnitt_start=date('d.m.y',$_SESSION['kalender_'.$modul.'_spanne_start']);
    $zeitabschnitt_ende=date('d.m.y',$_SESSION['kalender_'.$modul.'_spanne_ende']);
    $zeitabschnitt=$zeitabschnitt_start.'-'.$zeitabschnitt_ende;
    }
   }
  else $zeitabschnitt='gesamt';

  echo '   <table class="modul">';
  echo "\n".'    <tr><th colspan="2" class="modul">'.konsole($modul).'Hits/'.$name.' <span class="spanne">('.$zeitabschnitt.")</span></th></tr>\n   ";
  $_SESSION["modul_".$modul."_werte"]=$$modul;
  $_SESSION["modul_".$modul."_gesamt"]=$gesamt;
  
  // ______________________Kreisdiagramme______________________
  if(in_array($modul,$module_diagramme) && $diagrammE[$modul]!=1)
   {
   ?>
   <tr>
    <td><a href="kreis_zoom.php?modul=<?php echo $modul; ?>&amp;<?php echo SID; ?>" onclick="kreis_zoom=window.open('kreis_zoom.php?modul=<?php echo $modul; ?>&amp;<?php echo SID; ?>','kreis_zoom','height=420, width=700'); kreis_zoom.focus(); return false;" target="_blank"><img src='kreisdiagramm.php?modul=<?php echo $modul; ?>&amp;<?php echo SID; ?>' alt="Kreisdiagramm <?php echo $name; ?>" width="<?php echo $config_stat_kreisdiagramm_groesse; ?>" height="<?php echo $config_stat_kreisdiagramm_groesse; ?>" /></a></td>
    <td>
    <?php
    if($config_stat_scroll && in_array($modul, $module_limit))
     {
     echo '<div style="width:180px; height:1px;"></div>'; // Minwidth-ersatz
     if($modul=='browser') { $h=102; $w=$config_stat_scroll_middle-100; }
     else { $h=102; $w=$config_stat_scroll_right-100; }
     echo '<div class="daten" style="height:'.$h.'px;">';
     }
    ?>
     <table class="daten">
      <tr><th><?php echo $name; ?></th><th>Anzahl</th><th>Proz.</th></tr>
      <?php
      $farben=$config_stat_farben;
      $grauton=0;
      $i=0;
      foreach($$modul as $eintrag => $anzahl)
       {
       if(((!isset($_SESSION[$modul."_all"]) || $_SESSION[$modul."_all"]==0) && $i<$config_stat_limit[$modul]) || $_SESSION[$modul."_all"]==1)
        {
        $prozent=prozent($anzahl,$gesamt);
        if(!isset($farben[$i]))
         {
         $grauton+=20;
         if($grauton>255) $grauton=0;
         $farben[$i]="rgb(".$grauton.",".$grauton.",".$grauton.")";
         }
        echo "<tr><td><span style='background-color:".$farben[$i].";'>&nbsp;&nbsp;</span>&nbsp;".$eintrag."</td><td>".$anzahl."</td><td>".$prozent." %</td></tr>";
        $i++;
        }
       }
      ?>

     </table>
    <?php
    if($config_stat_scroll && in_array($modul, $module_limit)) echo '</div>';
    ?>

    </td>
   </tr>
   <?php
   }
  // ______________________Baumdarstellung der referer______________________
  elseif($modul=='referer' && $_SESSION['referer_tree'])
   {
   // Referer zusammenfassen
   $referer2=$referer;
   unset($referer);
   foreach($referer2 as $referrer=>$anzahl)
    {
    $url_info=parse_url($referrer);
    if(!isset($url_info['host'])) $url_info['host']='';
    $referer[$url_info['host']][$referrer]=$anzahl;
    }
   // Array mit Anzahl hits pro Host erstellen
   $gesamt_hosts=0;
   if($config_stat_lange_balken) $gesamt2=0;
   
   if(isset($referer)) foreach($referer as $eintrag=>$wert)
    {
    if(is_array($wert))
     {
     $hostanz_array[$eintrag]=0;
     foreach($wert as $wert2) $hostanz_array[$eintrag]+=$wert2;
     @$gesamt_hosts+=$hostanz_array[$eintrag];
     if($config_stat_lange_balken && $hostanz_array[$eintrag]>$gesamt2) $gesamt2=$hostanz_array[$eintrag];
     }
    }
   arsort($hostanz_array);


   if($mktree)  //  mit plugin mktree
    {
    echo ' <tr><th colspan="2">'.$name."<span class=\"ref130\">Anzahl</span><span style='position:absolute; right:510px'>Anteil</span></th></tr><tr><td colspan='2'><ul class='mktree' id='tree1'>";

    // Hosts durchgehen
    $i=0;
    if(isset($hostanz_array)) foreach($hostanz_array as $eintrag=>$hostanz)
     {
     $wert=$$modul;
     $wert=$wert[$eintrag];
     // Ausgabe
     if(!isset($config_stat_limit[$modul]) || (((!isset($_SESSION[$modul."_all"]) || $_SESSION[$modul."_all"]==0) && $i<$config_stat_limit[$modul]) || $_SESSION[$modul."_all"]==1))
      {
      echo '<li>';
      $prozent=prozent($hostanz,$gesamt_hosts);
      if(isset($gesamt2)) $prozent2=round(prozent($hostanz,$gesamt2)/100*$config_stat_balken_laenge);
      else $prozent2=round($prozent/100*$config_stat_balken_laenge);
      $rest=$config_stat_balken_laenge-$prozent2;
      if(is_string($eintrag)) echo $eintrag;  // Hostname ausgeben
      if(is_array($wert))                     // einzelne Referer durchgehen
       {
       echo '<span class="ref130">'.$hostanz.'</span><span class="ref20"><img src="blue.gif" height="10" width="'.$prozent2.'" title="'.$prozent.'%" alt="'.$prozent.'%" /><img src="grau.gif" height="10" width="'.$rest.'" title="'.$prozent.'%" alt="" /></span>'; // Anzahl Hits  und Balken des Host
       echo '<ul>';
       arsort($wert);
       foreach($wert as $eintrag2=>$wert2)    // Einzelne Referer des hosts durchgehen
        {
        if(strlen($eintrag2)>100)            // kuerzen?
         {
         $eintrag2_ungekuertzt=$eintrag2;
         $eintrag2=substr($eintrag2,0,100)."[...]";
         }
        else $eintrag2_ungekuertzt=$eintrag2;
        $eintrag2='<a href="'.linkprep($eintrag2_ungekuertzt).'" class="referer" target="_blank">'.htmlentities($eintrag2).'</a>'."\n";
        echo '<li>'.$eintrag2;   // einzelnen referer ausgeben
        if(is_int($wert2))
         {
         $prozent=prozent($wert2,$gesamt_hosts);
         if(isset($gesamt2)) $prozent2=round(prozent($wert2,$gesamt2)/100*$config_stat_balken_laenge);
         else $prozent2=round($prozent/100*$config_stat_balken_laenge);
         $rest=$config_stat_balken_laenge-$prozent2;
         echo '<span class="ref130">'.$wert2.'</span><span class="ref20"><img src="extensions/lightblue.gif" height="10" width="'.$prozent2.'" title="'.$prozent.'%" alt="'.$prozent.'%" /><img src="grau.gif" height="10" width="'.$rest.'" title="'.$prozent.'%" alt="" /></span>';
         }
        echo '</li>';
        }
       echo '</ul>';
       }
      echo '</li>';
      }
     $i++;
     }
    echo '</ul>';
    }
   elseif($ajaxTree) //mit plugin ajaxTree
    {
    echo ' <tr><td colspan="2">';
    // Speichere Baum-Daten in Session fuer ref_pages.php
    $_SESSION['modul_referer_hosts']=$referer;
    // Speichere Keys fr refpages.php
    $_SESSION['modul_referer_keys']=array_keys($hostanz_array);

    $anz_hosts=count($hostanz_array);
    if(isset($config_stat_limit[$modul]) && $anz_hosts>$config_stat_limit[$modul] && (!isset($_SESSION[$modul."_all"]) || !$_SESSION[$modul."_all"])) $anz_hosts=$config_stat_limit[$modul];
    // Uebergebe Daten an JavaScript
    $js='<script type="text/javascript" language="javascript"> var laenge='.$config_stat_balken_laenge.'; var gesamt='.$gesamt_hosts.'; var gesamt2='.(isset($gesamt2)?$gesamt2:$gesamt).'; var host_anz='.$anz_hosts.'; var childs=new Array(0';
    ?>
    <table style="width:100%" cellpadding="0" cellspacing="0">
     <colgroup>
      <col width="10" />
      <col width="*" />
      <col width="50" />
      <col width="110" />
     </colgroup>
     <thead>
      <tr><th colspan="2"><?php echo $name; ?></th><th>Anzahl</th><th>Anteil</th></tr>
     </thead>
     <tbody id="tabelle">
    <?php
    // Hosts durchgehen
    $id=0;
    if(isset($hostanz_array)) foreach($hostanz_array as $eintrag=>$hostanz)
     {
     $id++;
     // Ausgabe
     if(!isset($config_stat_limit[$modul]) || (((!isset($_SESSION[$modul."_all"]) || $_SESSION[$modul."_all"]==0) && $id<=$config_stat_limit[$modul]) || $_SESSION[$modul."_all"]==1))
      {
      $prozent=prozent($hostanz,$gesamt_hosts);
      if(isset($gesamt2)) $prozent2=round(prozent($hostanz,$gesamt2)/100*$config_stat_balken_laenge);
      else $prozent2=round($prozent/100*$config_stat_balken_laenge);
      $rest=$config_stat_balken_laenge-$prozent2;
      $handle='onclick="menuclick('.$id.'); return false;"';
      $js.=','.count($referer[$eintrag]);
      ?>
<tr id="row<?php echo $id; ?>" class="ajaxTreeZeile<?php echo $id%2; ?>">
       <td><img src="extensions/ajaxTree/plus<?php if($anz_hosts==1) echo '5'; elseif($id==1) echo '1'; elseif($id==$anz_hosts) echo '3'; else echo '2';  ?>.gif" alt="+" title="" id="pic<?php echo $id; ?>" <?php echo $handle; ?> class="ajaxTreeHand" /></td>
       <td><a href="nojs.html" <?php echo $handle; ?> class="ajaxTreeDomain"><?php echo $eintrag; ?> </a></td>
       <td><?php echo $hostanz; ?></td>
       <td><img src="blue.gif" height="10" width="<?php echo $prozent2; ?>" title="<?php echo $prozent; ?>%" alt="<?php echo $prozent; ?>%"  /><img src="grau.gif" height="10" width="<?php echo $rest; ?>" title="<?php echo $prozent; ?>%" alt=""  /></td>
      </tr>
      <?php
      }
     }
    echo $js='</tbody></table>'.$js.'); </script>';
    }
   echo '</td></tr>';
   }
  // ______________________Balkendiagramme______________________
  else
   {
   echo ' <tr><td colspan="2">';
   if($config_stat_scroll && in_array($modul, $module_limit) && $modul!='referer' && $modul!='keywords')
    {
    echo '<div style="width:300px; height:1px"></div>';  // Minwidth-ersatz
    if($modul=='browser') $h=102;
    elseif($modul=='dateien') $h=244;
    elseif($modul=='farbtiefen') $h=82;
    else $h=102;
    echo '<div style="height:'.$h.'px; width:100%; overflow:auto">';
    }
   echo '<table class="daten"><tr><th>'.$name.'</th><th>Anz'.($modul=='tage'?'.':'ahl').'</th><th>Anteil</th></tr>';
   if($modul=='wochentage') $tag_namen=array('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag','Sonntag');
   $i=0;
   if(isset($$modul)) foreach($$modul as $eintrag=>$anzahl)
    {
    if(!isset($config_stat_limit[$modul]) || (((!isset($_SESSION[$modul.'_all']) || $_SESSION[$modul.'_all']==0) && $i<$config_stat_limit[$modul]) || $_SESSION[$modul.'_all']==1))
     {
     $prozent=prozent($anzahl,$gesamt);
     if(isset($gesamt2)) $prozent2=round(prozent($anzahl,$gesamt2)/100*$config_stat_balken_laenge);
     else $prozent2=round($prozent/100*$config_stat_balken_laenge);
     $rest=$config_stat_balken_laenge-$prozent2;
     if(isset($max[$modul.'_name']) && $eintrag==$max[$modul.'_name']) $markiere=" style='".$config_stat_max_style."'"; else $markiere='';
     if($modul=='dateien')
      {
      $eintrag=urldecode($eintrag);
      $eintrag_ungekuertzt=$eintrag;
      $eintrag=basename($eintrag);
      if($eintrag_ungekuertzt[strlen($eintrag_ungekuertzt)-1]=='/') $eintrag.='/';
      if(strlen($eintrag)>$config_stat_dateien_maxlength) $eintrag=substr($eintrag,0,$config_stat_dateien_maxlength-2).'[...]';
      $eintrag=htmlentities($eintrag);
      }
     elseif($modul=='farbtiefen')
      {
      $eintrag='<span title="'.pow(2,$eintrag).' Farben">'.prettyInt(pow(2,$eintrag)). ' Farben ('.$eintrag.' Bit)</span>';
      }
     if($modul=='referer')
      {
      $eintrag_ungekuertzt=$eintrag;
      $eintrag=htmlentities(substr($eintrag,0,100)).' '.htmlentities(substr($eintrag,100,100));
      }
     elseif(!isset($eintrag_ungekuertzt)) $eintrag_ungekuertzt=$eintrag;
     if($modul=='wochentage' && isset($tag_namen[$eintrag])) $eintrag=$tag_namen[$eintrag];
     elseif($modul=='referer') $eintrag='<a href="'.linkprep($eintrag_ungekuertzt).'" class="referer" target="_blank">'.$eintrag.'</a>';
     if($modul=='dateien') echo "<tr><td title='".str_replace("'",'&#39;',htmlentities($eintrag_ungekuertzt))."' style='cursor:help'>".$eintrag."</td>";
     else echo '<tr><td'.$markiere.'>'.$eintrag.'</td>';
     echo '<td'.$markiere.'>'.$anzahl.'</td><td'.$markiere.'><img src="blue.gif" height="10" width="'.$prozent2.'" title="'.$prozent.'%" alt="'.$prozent.'%" /><img src="grau.gif" height="10" width="'.$rest.'" title="'.$prozent.'%" alt="" /></td></tr>'."\n    ";
     unset($eintrag_ungekuertzt);
     $i++;
     }
    }
   echo '</table>';
   if($config_stat_scroll && in_array($modul, $module_limit) && $modul!='referer' && $modul!='keywords')
    {
    echo '</div>';
    }
   echo '</td></tr>';
   }
  echo "\n".'   </table>';
  }
 echo "\n".'   <!-- Ende Modul '.ucfirst($modul).' -->'."\n";
 }

// Prozent-Funktion
function prozent($teil, $gesamt)
 {
 if($gesamt==0) return 0;
 return @round($teil/$gesamt*100);
 }

function prettyInt($number)
 {
 $suffix=array('Milo.','Mrd.','Billionen','Billiarden','Trillionen','Trilliarden');
 $i=-2;
 if($number<1000000)
  {
  $number=number_format($number,0,',','.');
  return $number;
  }
 while($number>=1000 && $i<(count($suffix)-1))
  {
  $number/=1000;
  $i++;
  }
 if($i>=(count($suffix)-1))
  {
  $number=number_format($number,0,',','.').' '.$suffix[$i];
  return $number;
  }
 return str_replace('.',',',round($number,1)).' '.$suffix[$i];
 }

function save_results($why)
 {
 global $handle, $time, $module, $ips, $ips_dateien, $ips_online, $config_ip_sperre_zeit, $default_filename;

 // Loeschen nicht benoetigter IP-Daten
 $timecontrol=floor($time['stamp']/60/$config_ip_sperre_zeit);
 if(!empty($ips)) foreach($ips as $ip=>$check_timecontrol) if($check_timecontrol!=$timecontrol) unset($ips[$ip]);
 if(!empty($ips_dateien)) foreach($ips_dateien as $ipfile=>$check_timecontrol)  if($check_timecontrol!=$timecontrol) unset($ips_dateien[$ipfile]);
 if(!empty($ips_online)) foreach($ips_online as $ip=>$check_timecontrol) if($check_timecontrol!=$timecontrol) unset($ips_online[$ip]);

 $vars_to_save=array_merge(array('pos'=>ftell($handle),'letzte_daten','logdatei_name','hits_user_tag','ips','ips_dateien','ips_online','log_file_number'),$module);
 if($why=='dfc')
  {
  $vars_to_save['save_monat']=$time['monat'];
  $vars_to_save['save_jahr']=$time['jahr'];
  $vars_to_save[]='usr_on_stamp';
  $dfcache='<?php'."\n//Dies ist eine temporaere Datei die automatisch von CrazyStat erstellt wurde. Sie koennen sie loeschen, CrazyStat wird dann (nur) beim naechsten mal langsamer sein.\n";
  }
 foreach($vars_to_save as $var=>$val)
  {
  if(is_int($var))
   {
   global $$val;
   $var=$val;
   $val=$$var;
   }
  if($why=='goon') $_SESSION['goon_'.$var]=$val;
  else  $dfcache.="\n".'$'.$var.'='.var_export($val,true).';';
  }
 unset($vars_to_save);
 if($why=='dfc')
  {
  $dfcache.="\n?>";  //<?php
  @$dfcache_handle=fopen('cache/'.$default_filename,'w');
  if(!$dfcache_handle) echo '<p class="meldung">cache/'.$default_filename.' konnte nicht zum Schreiben ge&ouml;ffnet werden.<br />&Uuml;berpr&uuml;fen Sie den CHMOD (siehe LIESMICH.txt).</p>';
  else
   {
   fwrite($dfcache_handle,$dfcache);
   fclose($dfcache_handle);
   }
  }
 }

if(isset($_GET['d']) && $_GET['d']) $_SESSION['debug']=true;
elseif(isset($_GET['d']) || !isset($_SESSION['debug'])) $_SESSION['debug']=false;

if($_SESSION['debug']==true)
 {
 $ende=getmicrotime();
 $zeit=$ende-$start;
?>
  <span style="font-size:12pt;"><?php echo $zeit; ?></span>
<?php
 }

$script_complete=true;

function script_ende()  // Wird beim Verlassen des Scriptes aufgerufen
 {
 global $script_complete, $module, $handle, $letzte_daten, $logdatei_name,$hits_user_tag;
 if(!$script_complete) // Script nicht durchgelaufen (max_execution_time?)
  {
  $c=fgetc($handle);
  while($c!= "\n" && $c!==false) // Aktuelle Zeile ueberspringen
   {
   $c=fgetc($handle);
   }
  save_results('goon');   // Variablen sichern
  foreach($module as $modul) unset($_SESSION['modul_'.$modul.'_werte']);

  // Meldung & Link ausgeben
  echo '<p class="meldung">';
  echo 'Die Statistik konnte nicht vollst&auml;ndig ausgewertet werden. Wahrscheinlich wurde die maximale Ausf&uuml;hrzeit &uuml;berschritten. Dies ist eine Beschr&auml;nkung auf Ihrem Server. CrazyStat kann mit dem Auswerten der Statistik fortfahren. Es kann sein, dass sie mehrmals "Fortfahren" klicken m&uuml;ssen.<br />';
  echo '<br />Aktuelle Position: Byte '.$_SESSION['goon_pos'].' in '.$logdatei_name.'<br />';
  echo '<a href="show_stat.php?goon=1';
  foreach($_GET as $key=>$val) echo '&amp;'.$key.'='.$val;
  echo '&amp;'.SID.'">Fortfahren</a></p></body></html>';
  }
 }
?>
 </body>
</html>